import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.sql.*;

/**
 * View principal de la aplicacion
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AppView extends WindowAdapter {
    private JFrame fr = new JFrame("SISTEMA FACTURACION");
    private JMenuBar mb = new JMenuBar();
    private JMenu mcli = new JMenu("Cliente");
    private JMenu mpro = new JMenu("Producto");
    private JMenu mfac = new JMenu("Factura");
    private JMenuItem micli1 = new JMenuItem("Alta");
    private JMenuItem micli2 = new JMenuItem("Consulta 1");
    private JMenuItem micli3 = new JMenuItem("Consulta 2");
    private JMenuItem micli4 = new JMenuItem("Consulta 3");
    private JMenuItem mipro1 = new JMenuItem("Alta");
    private JMenuItem mifac1 = new JMenuItem("Nueva Factura");
    private Login log = null;
    private JPanel pNorth = new JPanel();
    private JPanel pSouth = new JPanel();
    private JPanel pEast = new JPanel();
    private JPanel pWest = new JPanel();
    private JPanel pCenter = new JPanel();
    

    /**
     * Constructor for objects of class AppView
     */
    public AppView() {
    }
    public AppView(Login l) {
        log = l;
        //
        // agrego menu items a menues
        mcli.add(micli1);
        mcli.add(micli2);
        mcli.add(micli3);
        mcli.add(micli4);
        mpro.add(mipro1);
        mfac.add(mifac1);
        // agrego menues a menu bar
        mb.add(mcli);
        mb.add(mpro);
        mb.add(mfac);
        fr.getContentPane().add("North",pNorth);
        fr.getContentPane().add("South",pSouth);
        fr.getContentPane().add("East",pEast);
        fr.getContentPane().add("West",pWest);
        fr.getContentPane().add("Center",pCenter);
        // indico menu del JFrame
        fr.setJMenuBar(mb);
        
        // initialise instance variables
        fr.addWindowListener(this);
        micli1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono alta de cliente!");
                removeComponent();
                JTextField txtCodigo = new JTextField("");
                JTextField txtDescr = new JTextField("");
                JTextField txtSaldo = new JTextField("0.0");
                JLabel lblCodigo = new JLabel("Codigo");
                JLabel lblDescr = new JLabel("Descripcion");
                JLabel lblSaldo = new JLabel("Saldo");
                JButton btn = new JButton("Grabar");
                JPanel pfrm = new JPanel(new SpringLayout());
                lblCodigo.setLabelFor(txtCodigo);
                lblDescr.setLabelFor(txtDescr);
                lblSaldo.setLabelFor(txtSaldo);
                pfrm.add(lblCodigo);
                pfrm.add(txtCodigo);
                pfrm.add(lblDescr);
                pfrm.add(txtDescr);
                pfrm.add(lblSaldo);
                pfrm.add(txtSaldo);
                pfrm.add(new JLabel(""));
                pfrm.add(btn);

                //
                txtCodigo.setEnabled(false);
                try {
                    ResultSet rs = DataIO.getResultSet("SELECT COALESCE(MAX(IDC)+1,1) FROM TBL_CLIENTE");
                    if ( rs.next() ) {
                        txtCodigo.setText(rs.getString(1));
                    }
                    rs.close();
                } catch(SQLException sqle) {
                    txtCodigo.setText("1");
                }
                
                // events
                btn.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //validar
                        if ( txtDescr.getText().length() < 1 ) {
                            JOptionPane.showMessageDialog(null, "Debe Ingresar una descripcion", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            txtDescr.requestFocus();
                            return;
                        }
                        try {
                            Double d = new Double(txtSaldo.getText());
                            if ( d < 0 ) {
                                JOptionPane.showMessageDialog(null, "Debe Ingresar un saldo mayor que cero", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                                txtSaldo.requestFocus();
                                return;
                            }
                        }catch(NumberFormatException nfe) {
                            JOptionPane.showMessageDialog(null, "["+txtSaldo.getText()+"] no es un numero!", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            txtSaldo.requestFocus();
                            return;
                        }
                        //insertar cliente en b.d.
                        
                        if ( DataIO.executeQuery("INSERT INTO TBL_CLIENTE(IDC,DESCR,SALDO) VALUES("+txtCodigo.getText()+",'"+txtDescr.getText()+"',"+txtSaldo.getText()+")") ) {
                            DataIO.doCommit();
                            JOptionPane.showMessageDialog(null, "Cliente dado de Alta Ok!", "Info", JOptionPane.INFORMATION_MESSAGE);
                        } else {
                            JOptionPane.showMessageDialog(null, "Error ["+DataIO.getErrorMessages()+"] al intentar dar de alta Cliente!", "Error BD", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                });
                
                //Lay out the panel.
                SpringUtilities.makeCompactGrid(pfrm,
                                                4, 2, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                                                
                pCenter.add(pfrm);
                refresh();
            }
        });

/**
 * Opcion de consulta 1 consulta muy basica sobre cliente
 */
        micli2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 1 de cliente!");
                removeComponent();
                JTable tbl = new JTable();
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
/***********************************************************************************
 *               EJEMPLO BASICO CON CLASE ANONIMA
 ***********************************************************************************                
                tbl.setModel(new AbstractTableModel() {
                    private ResultSet rs = null;
                    public int getRowCount() {
                        return 2;
                    }
                    public int getColumnCount() {
                        return 3;
                    }
                    public Object getValueAt(int row, int column) {
                        return ""+row+","+column;
                    }
                });
***********************************************************************************                                
*/                
                ClienteModel tblm = new ClienteModel(rs);
                tbl.setModel(tblm);
                pCenter.add(tbl);
                refresh();
            }
        });
/**
 * Opcion de consulta 2 que permite hacer abm simple sobre grilla y base de datos
 */
        micli3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 2 de cliente!");
                removeComponent();
                JPanel pEste = new JPanel();
                JTable tbl = new JTable();
                JButton btnAlta = new JButton("Alta");
                JButton btnBaja = new JButton("Baja");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
                ClienteModel2 tblm = new ClienteModel2(rs);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                tbl.setModel(tblm);
                pEste.setLayout(new GridLayout(5,1));
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pCenter.add(scp);
                pEast.add(pEste);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.agregar();
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            tblm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                refresh();
            }
        });
        
/**
 * Opcion de consulta 3 que permite hacer abm simple sobre grilla y base de datos
 */
        micli4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 3 de cliente!");
                removeComponent();
                JPanel pEste = new JPanel();
                JTable tbl = new JTable();
                JButton btnAlta = new JButton("Alta");
                JButton btnBaja = new JButton("Baja");
                JButton btnGuardar = new JButton("Guardar");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
                ClienteModel3 tblm = new ClienteModel3(rs);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                tbl.setModel(tblm);
                btnGuardar.setEnabled(false);
                pEste.setLayout(new GridLayout(7,1));
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(btnGuardar);
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pEste.add(new JLabel(""));
                pCenter.add(scp);
                pEast.add(pEste);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.agregar(btnAlta,btnBaja,btnGuardar);
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            tblm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                btnGuardar.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.guardar();
                    }
                });
                refresh();
            }
        });
        
        fr.setLocationRelativeTo(null); // centrado
        // PASO 7 CONFIGURAR EL TAMA#O DEL CONTENEDOR
        fr.setSize(500,400);
        // PASO 8 HACER EL CONTENEDOR VISIBLE
        fr.setVisible(true);
    }
    
    // windows events que nos interesan
    // sobre-escribo metodo windowClosed()
    @Override
    public void windowClosing(WindowEvent e) {
         log.cierroAplicacion();
    }

    private void removeComponent() {
        pNorth.removeAll();
        pSouth.removeAll();
        pEast.removeAll();
        pWest.removeAll();
        pCenter.removeAll();
    }
    private void refresh() {
        // refresh
        fr.pack();
        fr.invalidate();
        fr.validate();
    }
}
