import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.sql.*;
import java.util.*;
/**
 * Implementamos metodos abstractos de AbstractTableModel
 * Implementacion basica de model para JTable
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class ClienteModel extends AbstractTableModel {
    private ResultSet rs = null;
    private List<Cliente> lst = new ArrayList<Cliente>();
    public ClienteModel(ResultSet r) {
        rs = r;
        try {
            while(rs.next()) {
                lst.add(new Cliente(rs.getInt("idc"),rs.getString("descr"),rs.getDouble("saldo")));
            }
            rs.close();
        } catch(SQLException sqle) {
            System.err.println("ClienteModel(): Error "+sqle.getMessage());
        }
    }
    public int getRowCount() {
        return lst.size();
    }
    public int getColumnCount() {
        return 3;
    }
    public Object getValueAt(int row, int column) {
        Cliente c = lst.get(row);
        switch(column) {
            case 0:
                return new Integer(c.getIdc());
            case 1:
                return c.getDescripcion();
            case 2:
                return new Double(c.getSaldo());
        }
        return ""+row+","+column;
    }
}
