import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
/**
 * Write a description of class LoginController here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LoginController extends WindowAdapter implements ActionListener {
    private Login log = null;
    public LoginController() {
    }
    public LoginController(Login login) {
        log=login;
    }
    public void actionPerformed(ActionEvent e) {
        JButton b = (JButton) e.getSource();
        if ( b.getText().equals("Login") ) {
            // intento Login en base de datos
            // si login Ok -> grabo parametros
            // obtengo los datos a grabar
            String servidor = ((JTextField) log.getComponente("servidor")).getText();
            String puerto = ((JTextField) log.getComponente("puerto")).getText();
            String bd = ((JTextField) log.getComponente("bd")).getText();
            String usuario = ((JTextField) log.getComponente("usuario")).getText();
            String rol = ((JTextField) log.getComponente("rol")).getText();
            char[] cpwd = ((JPasswordField) log.getComponente("pwd")).getPassword();
            String pwd = new String(cpwd);
            DataIO.setAppName("FACTURACION");
            
            DataIO.setDatabase(servidor+"/"+puerto+":"+bd);
            DataIO.setUser(usuario,pwd,rol);
            if ( DataIO.init() ) {
                // conectado a firebird database server !!!
                graboParametros();
                log.getJFrame().setVisible(false);
                new AppView(log);
            } else {
                // maldicion! login fallido!!
                log.getComentario().setText(DataIO.getErrorMessages());
                DataIO.clearErrorMessages();
            }
        }
        if ( b.getText().equals("Cancel") ) {
            log.cierroAplicacion();
        }
    }
    /**
     * Metodo utilizado para cargar los parametros del ultimo login satisfactorio
     * desde el archivo facturacion.prop
     */
    public void cargoParametros() {
        // si existe facturacion.properties cargo los valores de los JTextFields desde archivo de propiedades
        File f = new File("facturacion.properties");
        if ( f.exists() ) {
            if ( f.canRead() ) {
                System.out.println("Archivo facturacion.properties existe y puedo leerlo!");
                // lectura del archivo de propiedades
                Properties p = new Properties();
                try {
                    FileInputStream fis = new FileInputStream(f);
                    p.load(fis);
                    fis.close();
                    // cargar propiedades a componentes
                    ((JTextField) log.getComponente("servidor")).setText(p.getProperty("servidor"));
                    ((JTextField) log.getComponente("puerto")).setText(p.getProperty("puerto"));
                    ((JTextField) log.getComponente("bd")).setText(p.getProperty("bd"));
                    ((JTextField) log.getComponente("usuario")).setText(p.getProperty("usuario"));
                    ((JTextField) log.getComponente("rol")).setText(p.getProperty("rol"));
                } catch(IOException ioe) {
                    System.err.println("LoginController.cargoParametros(): Error! leyendo facturacion.properties "+ioe.getMessage());
                }
            } else {
                System.out.println("Archivo facturacion.properties existe, pero no puedo leerlo!");
            }
        } else {
            System.out.println("Archivo facturacion.properties no existe!");
        }
    }
    /**
     * Metodo utilizado para grabar los parametros del ultimo login satisfactorio
     * hacia el archivo facturacion.prop
     */
    public void graboParametros() {
        // si existe facturacion.properties cargo los valores de los JTextFields desde archivo de propiedades
        File f = new File("facturacion.properties");
        if ( f.exists() ) {
            if ( f.canWrite() ) {
                System.out.println("Archivo facturacion.properties existe y puedo grabarlo!");
                // lectura del archivo de propiedades
                Properties p = new Properties();
                try {
                    FileOutputStream fos = new FileOutputStream(f);
                    Date d = new Date();
                    // cargar propiedades desde los componentes
                    p.setProperty("servidor",((JTextField) log.getComponente("servidor")).getText());
                    p.setProperty("puerto",((JTextField) log.getComponente("puerto")).getText());
                    p.setProperty("bd",((JTextField) log.getComponente("bd")).getText());
                    p.setProperty("usuario",((JTextField) log.getComponente("usuario")).getText());
                    p.setProperty("rol",((JTextField) log.getComponente("rol")).getText());
                    p.store(fos,"Sistema Facturacion, archivo grabado el "+d);
                    fos.close();
                } catch(IOException ioe) {
                    System.err.println("LoginController.cargoParametros(): Error! leyendo facturacion.properties "+ioe.getMessage());
                }
            } else {
                System.out.println("Archivo facturacion.properties existe, pero no puedo leerlo!");
            }
        } else {
            System.out.println("Archivo facturacion.properties no existe!");
        }
    }
    
    // windows events que nos interesan
    // sobre-escribo metodo windowClosed()
    @Override
    public void windowClosing(WindowEvent e) {
         log.cierroAplicacion();
    }
}
